diff --git a/src/snmp.c b/src/snmp.c
index 33a76e33f0..3d6604183e 100644
--- a/src/snmp.c
+++ b/src/snmp.c
@@ -656,7 +656,10 @@ static int csnmp_config_add_host (oconfig_item_t *ci)
 
   status = cf_util_get_string(ci, &hd->name);
   if (status != 0)
+  {
+    sfree (hd);
     return status;
+  }
 
   hd->sess_handle = NULL;
   hd->interval = 0;
